unit MYInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ExtCtrls, Buttons, ActnList, ImgList;

type
  TFormInfo = class(TForm)
    Panel1: TPanel;
    PanelButtons: TPanel;
    Panel3: TPanel;
    GroupBox1: TGroupBox;
    Label6: TLabel;
    Label7: TLabel;
    Label12: TLabel;
    Label11: TLabel;
    Panel2: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    SpeedButton1: TSpeedButton;
    ActionList1: TActionList;
    ActionExit: TAction;
    Panel4: TPanel;
    Image2: TImage;
    ImageList1: TImageList;
    procedure Label11Click(Sender: TObject);
    procedure Label12Click(Sender: TObject);
    Procedure MyExecute(cExec : String);
    procedure ActionExitExecute(Sender: TObject);
    procedure Panel4MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    { Private declarations }
    procedure MyIdle(Sender: TObject; var Done: Boolean);
  public
    { Public declarations }
  end;

Procedure ShowInfo;

implementation

uses
  ShellAPI;
{$R *.DFM}


Const
  lGo : Boolean = FALSE;
  ScrollText : String = 'Copyright  2000 - Andr Scholten * ' +
                        'Email: surfsup@dds.nl * ' +
                        'Website: http://members.xoom.com/itplayer * ';

Procedure ShowInfo;
Begin
  with TFormInfo.Create(Application) do
  try
    Label3.Caption := Copy(ScrollText, 1, 23);
    Application.OnIdle := MyIdle;
    lGo := TRUE;
    ShowModal;
    lGo := FALSE;
  finally
    Free;
  end;
end;

Procedure TFormInfo.MyExecute(cExec : String);
Var
   St : PChar;
Begin
  GetMem(St, 100);
  ShellExecute(Handle, 'open', StrPCopy(St, cExec), nil, nil, SW_SHOW);
  FreeMem(St, 100);
  ModalResult := mrOk;
  Application.ProcessMessages;
end;

procedure TFormInfo.Label11Click(Sender: TObject);
begin
  MyExecute('mailto:' + Label11.Caption);
end;

procedure TFormInfo.Label12Click(Sender: TObject);
begin
  MyExecute(Label12.Caption);
end;

procedure TFormInfo.ActionExitExecute(Sender: TObject);
begin
  ModalResult := mrOk;
end;

Var
  MyMouse : TMouse;

procedure TFormInfo.Panel4MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
  if csLButtonDown in Panel4.ControlState then
  Begin
    Left := MyMouse.CursorPos.x - (Width div 2);
    Top  := MyMouse.CursorPos.y - (Panel4.Height div 2);
  end;
end;

Procedure AntiFlicker; Assembler; Far;  // wacht op "vertical retrace"...
asm;
  mov  dx, 3DAh
@VERT:
  in   al, dx
  test al, 8
  jnz  @VERT
@NOVERT:
  in   al, dx
  test al, 8
  jz   @NOVERT
end;

procedure TFormInfo.MyIdle(Sender: TObject; var Done: Boolean);
Const
   nTel : Byte = 0;

begin
  if not lGo then Exit;
  Inc(nTel);
  AntiFlicker;
  Label3.Left := Label3.Left - 1;
  if nTel = 8 then
  Begin
    nTel := 0;
    ScrollText := Copy(ScrollText, 2, Length(ScrollText) -1) +
                       ScrollText[1];
    Label3.Left := Label3.Left + 8;
    Label3.Caption := Copy(ScrollText, 1, 23);
  end;
  Done := TRUE;
end;

end.

